#TEMPLATE(CodeMax, 'Codemax editor'),FAMILY('ABC')
#EXTENSION (CodeMaxGlobal, 'Initialize CodeMax DLL'), APPLICATION
    #PROMPT('Load Clarion Language?',CHECK),%CMGClarionLanguage,DEFAULT(1)
    #PROMPT('Load Profile?',CHECK),%CMGProfileLoad,DEFAULT(1)
    #PROMPT('Save Profile?',CHECK),%CMGProfileSave,DEFAULT(1)
  #DISPLAY('Template and Class')
  #DISPLAY('to use codemax dll')
  #DISPLAY('')
  #DISPLAY('  By Diego Martn Borojovich')
  #DISPLAY('     Di.M.Bo. Software')
  #DISPLAY('EMail:dimbo@netverk.com.ar')
  #DISPLAY('Buenos Aires - Argentina')
  #DISPLAY('2/28/2001')
  #DISPLAY('')
  #DISPLAY('CodeMax dll by ')
  #DISPLAY('Winmain')
  #DISPLAY('www.winmain.com')
#AT(%CustomGlobalDeclarations)
#PROJECT('cmax20.lib')
#ENDAT

#AT(%BeforeGlobalIncludes),WHERE(%ProgramExtension='EXE')
   INCLUDE('cmaxabc_.INC'),ONCE
#ENDAT

#AT(%GlobalData)
CodeMaxManager          CodeMaxManagerClass
#ENDAT

#! **************** CodeMaxManager Class *****************************

#AT(%ProgramSetup),WHERE(NOT %GlobalExternal)
CodeMaxManager.Init()
#IF(%CMGProfileLoad)
CodeMaxManager.LoadProfile()
#ENDIF
#IF(%CMGClarionLanguage)
CodeMaxManager.LoadClarionLanguage()
#ENDIF
#ENDAT
#AT (%ProgramEnd),WHERE(NOT %GlobalExternal)
#IF(%CMGProfileSave)
CodeMaxManager.SaveProfile()
#ENDIF
CodeMaxManager.Kill()
#ENDAT
#CONTROL(CodeMaxButtons,'CodeMax Buttons'),DESCRIPTION('CodeMax Buttons' & %ActiveTemplateInstance),WINDOW,REQ(CodeMax)
   CONTROLS
       BUTTON,AT(,,14,14),USE(?CMLoad),MSG('Load'),TIP('Load'),ICON('Open.ico')
       BUTTON,AT(16,0,14,14),USE(?CMSave),MSG('Save'),TIP('Save'),ICON('save.ico')
       BUTTON,AT(16,0,14,14),USE(?CMPrint),MSG('Print'),TIP('Print'),ICON('Print.ico')
       BUTTON,AT(16,0,14,14),USE(?CMUndo),DISABLE,MSG('Undo'),TIP('Undo'),ICON('UnDo.ico')
       BUTTON,AT(16,0,14,14),USE(?CMRedo),DISABLE,MSG('Redo'),TIP('Redo'),ICON('Redo.ico')
       BUTTON,AT(16,0,14,14),USE(?CMCut),DISABLE,MSG('Cut'),TIP('Cut'),ICON('Cut.ico')
       BUTTON,AT(16,0,14,14),USE(?CMCopy),DISABLE,MSG('Copy'),TIP('Copy'),ICON('Copy.ico')
       BUTTON,AT(16,0,14,14),USE(?CMPaste),DISABLE,MSG('Paste'),TIP('Paste'),ICON('Paste.ico')
       BUTTON,AT(16,0,14,14),USE(?CMRecordMacro),MSG('Record Macro'),TIP('Record Macro'),ICON('Macros.ico')
       BUTTON,AT(16,0,14,14),USE(?CMProperties),MSG('Properties'),TIP('Properties'),ICON('Properties.ico')
   END
#SHEET
  #TAB('General')
    #PROMPT('Hide When CodeMax Hide?',CHECK), %CMBHide, DEFAULT(1)
    #PROMPT('Notify Buttons?',CHECK), %CMBNotify, DEFAULT(1)
    #PROMPT('Load From',OPTION),%CMLoadFrom,DEFAULT('VARIABLE')
    #PROMPT('VARIABLE',RADIO)
    #PROMPT('SELF.FileName',RADIO)
    #PROMPT('BLOB',RADIO)
    #ENABLE(%CMLoadFrom='VARIABLE')
    #PROMPT('Variable Name:',FIELD),%CMLoadFromVariable
    #PROMPT('Support InteliLanguage?',CHECK),%CMLoadFromVariableInteli,DEFAULT(1)
    #ENDENABLE
    #ENABLE(%CMLoadFrom='BLOB')
    #PROMPT('BLOB Name:',EXPR),%CMLoadFromBlob
    #ENDENABLE
    #PROMPT('Save To',OPTION),%CMSaveTo,DEFAULT('VARIABLE')
    #PROMPT('VARIABLE',RADIO)
    #PROMPT('SELF.FileName',RADIO)
    #PROMPT('BLOB',RADIO)
    #ENABLE(%CMSaveTo='VARIABLE')
    #PROMPT('Variable Name:',FIELD),%CMSaveToVariable
    #ENDENABLE
    #ENABLE(%CMSaveTo='BLOB')
    #PROMPT('BLOB Name:',EXPR),%CMSaveToBlob
    #ENDENABLE
  #ENDTAB
#ENDSHEET

#ATSTART
  #DECLARE(%CMLoadControl)
  #DECLARE(%CMSaveControl)
  #DECLARE(%CMPrintControl)
  #DECLARE(%CMUndoControl)
  #DECLARE(%CMRedoControl)
  #DECLARE(%CMCutControl)
  #DECLARE(%CMCopyControl)
  #DECLARE(%CMPasteControl)
  #DECLARE(%CMRecordMacroControl)
  #DECLARE(%CMPropertiesControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?CMLoad')
        #SET(%CMLoadControl,%Control)
    #OF('?CMSave')
        #SET(%CMSaveControl,%Control)
    #OF('?CMPrint')
        #SET(%CMPrintControl,%Control)
    #OF('?CMUndo')
        #SET(%CMUndoControl,%Control)
    #OF('?CMRedo')
        #SET(%CMRedoControl,%Control)
    #OF('?CMCut')
        #SET(%CMCutControl,%Control)
    #OF('?CMCopy')
        #SET(%CMCopyControl,%Control)
    #OF('?CMPaste')
        #SET(%CMPasteControl,%Control)
    #OF('?CMRecordMacro')
        #SET(%CMRecordMacroControl,%Control)
    #OF('?CMPropertiesControl')
        #SET(%CMPropertiesControl,%Control)
    #ENDCASE
  #ENDFOR
#ENDAT

#AT (%CodeMaxMethodCodeSection,%ActiveTemplateParentInstance, 'Hide', '()'),Priority(5001),WHERE(%CMBHide)
  #IF(%CMUndoControl)
  HIDE(%CMUndoControl)
  #ENDIF
  #IF(%CMRedoControl)
  HIDE(%CMRedoControl)
  #ENDIF
  #IF(%CMCutControl)
  HIDE(%CMCutControl)
  #ENDIF
  #IF(%CMCopyControl)
  HIDE(%CMCopyControl)
  #ENDIF
  #IF(%CMPasteControl)
  HIDE(%CMPasteControl)
  #ENDIF
  #IF(%CMRecordMacroControl)
  HIDE(%CMRecordMacroControl)
  #ENDIF
  #IF(%CMPrintControl)
  HIDE(%CMPrintControl)
  #ENDIF
  #IF(%CMLoadControl)
  HIDE(%CMLoadControl)
  #ENDIF
  #IF(%CMSaveControl)
  HIDE(%CMSaveControl)
  #ENDIF
  #IF(%CMPropertiesControl)
  HIDE(%CMPropertiesControl)
  #ENDIF
#ENDAT

#AT (%CodeMaxMethodCodeSection,%ActiveTemplateParentInstance, 'TakeNotification', '(),LONG'),Priority(5001),WHERE(%CMBNotify)
  #IF(%CMUndoControl)
  IF SELF.CM_CanUndo()    THEN   ENABLE(%CMUndoControl)  ELSE DISABLE(%CMUndoControl).
  #ENDIF
  #IF(%CMRedoControl)
  IF SELF.CM_CanRedo()    THEN   ENABLE(%CMRedoControl)  ELSE DISABLE(%CMRedoControl).
  #ENDIF
  #IF(%CMCutControl)
  IF SELF.CM_CanCut()     THEN   ENABLE(%CMCutControl)   ELSE DISABLE(%CMCutControl).
  #ENDIF
  #IF(%CMCopyControl)
  IF SELF.CM_CanCopy()    THEN   ENABLE(%CMCopyControl)  ELSE DISABLE(%CMCopyControl).
  #ENDIF
  #IF(%CMPasteControl)
  IF SELF.CM_CanPaste()   THEN   ENABLE(%CMPasteControl) ELSE DISABLE(%CMPasteControl).
  #ENDIF
#ENDAT

#AT (%CodeMaxMethodCodeSection,%ActiveTemplateParentInstance, 'UnHide', '()'),Priority(5001),WHERE(%CMBHide)
  #IF(%CMUndoControl)
  UNHIDE(%CMUndoControl)
  #ENDIF
  #IF(%CMRedoControl)
  UNHIDE(%CMRedoControl)
  #ENDIF
  #IF(%CMCutControl)
  UNHIDE(%CMCutControl)
  #ENDIF
  #IF(%CMCopyControl)
  UNHIDE(%CMCopyControl)
  #ENDIF
  #IF(%CMPasteControl)
  UNHIDE(%CMPasteControl)
  #ENDIF
  #IF(%CMRecordMacroControl)
  UNHIDE(%CMRecordMacroControl)
  #ENDIF
  #IF(%CMPrintControl)
  UNHIDE(%CMPrintControl)
  #ENDIF
  #IF(%CMLoadControl)
  UNHIDE(%CMLoadControl)
  #ENDIF
  #IF(%CMSaveControl)
  UNHIDE(%CMSaveControl)
  #ENDIF
  #IF(%CMPropertiesControl)
  UNHIDE(%CMPropertiesControl)
  #ENDIF
#ENDAT

#AT(%ControlEventHandling,%CMUndoControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Undo()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMRedoControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Redo()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMCutControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Cut()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMCopyControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Copy()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMPasteControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Paste()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMRecordMacroControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_RecordMacro()
%ThisObjectName.SetFocus()
#ENDAT
#AT(%ControlEventHandling,%CMPrintControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Print()
#ENDAT
#AT(%ControlEventHandling,%CMLoadControl,'Accepted'),PRIORITY(5000)
#CASE(%CMLoadFrom)
#OF('VARIABLE')
%ThisObjectName.CM_OpenFile(%CMLoadFromVariable,%CMLoadFromVariableInteli)
#OF('SELF.FileName')
%ThisObjectName.CM_OpenFile()
#OF('BLOB')
%ThisObjectName.CM_OpenFile(%CMLoadFromBlob)
#END
#ENDAT
#AT(%ControlEventHandling,%CMSaveControl,'Accepted'),PRIORITY(5000)
#CASE(%CMSaveTo)
#OF('VARIABLE')
%ThisObjectName.CM_SaveFile(%CMSaveToVariable)
#OF('SELF.FileName')
%ThisObjectName.CM_SaveFile()
#OF('BLOB')
%ThisObjectName.CM_SaveFile(%CMSaveToBlob)
#END
#ENDAT
#AT(%ControlEventHandling,%CMPropertiesControl,'Accepted'),PRIORITY(5000)
%ThisObjectName.CM_Properties()
#ENDAT


#CONTROL(CodeMax,'CodeMax Control 32bit'),DESCRIPTION('CodeMax Control 32bit ' & %ActiveTemplateInstance),WINDOW,MULTI,REQ(CodeMaxGlobal)
#BOXED('Hidden Prompts'), AT(0,0,0,0), WHERE(%False), HIDE
#INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED


#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem,'CodeMax'&%ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), 'CodeMax'&%ActiveTemplateInstance,'CodeMaxClass')
#ENDPREPARE

   CONTROLS
     REGION,AT(,,165,25),USE(?CMRegion1)
   END
#ATSTART
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem, 'CodeMax' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), 'CodeMax' & %ActiveTemplateInstance, 'CodeMaxClass')
  #IF(%Target32 <> 1)
    #ERROR('Application must be compiled in 32 bit to use the control')
  #ENDIF
#ENDAT

#SHEET
  #TAB('General')
    #PROMPT('Help File: ', @s255), %CMHelpFIle, DEFAULT('C:\Clarion5\Bin\C5help.hlp')
    #DISPLAY('This is for contextual help on any word in CMControl')
    #DISPLAY('and use the F2 key on it.')
    #PROMPT('Set Clarion Language?',CHECK),%CMClarionLanguageSet,DEFAULT(1)
    #PROMPT('Load Profile?',CHECK),%CMProfileLoad,DEFAULT(1)
    #PROMPT('Save Profile?',CHECK),%CMProfileSave,DEFAULT(1)
    #PROMPT('Resize with Region Control?',CHECK),%CMResize,DEFAULT(1)
  #ENDTAB
  #TAB('Class')
#!     #BUTTON('Classes...')
      #WITH(%ClassItem, 'CodeMax' & %ActiveTemplateInstance)
        #INSERT(%ClassPrompts(ABC))
      #ENDWITH
#!     #ENDBUTTON
  #ENDTAB
  #TAB('About')
  #DISPLAY('Template and Class')
  #DISPLAY('to use codemax dll')
  #DISPLAY('')
  #DISPLAY('  By Diego Martn Borojovich')
  #DISPLAY('     Di.M.Bo. Software')
  #DISPLAY('EMail:dimbo@netverk.com.ar')
  #DISPLAY('Buenos Aires - Argentina')
  #DISPLAY('2/28/2001')
  #DISPLAY('')
  #DISPLAY('CodeMax dll by ')
  #DISPLAY('Winmain')
  #DISPLAY('www.winmain.com')
  #ENDTAB
#ENDSHEET

#!AT(%CustomGlobalDeclarations)
#!PROJECT('cmax20.lib')
#!ENDAT

#AT(%GatherObjects)
#CALL(%SetClassItem,'CodeMax' &%ActiveTemplateInstance)
#ADD(%ObjectList,'CodeMax' & %ActiveTemplateInstance)
#SET(%ObjectListType,'CodeMaxClass')
#ENDAT

#AT(%LocalDataClasses)
  #CALL(%SetClassItem, 'CodeMax' & %ActiveTemplateInstance)
#INSERT(%GenerateClassDefinition(ABC), %ClassLines)
#ENDAT

#AT(%LocalProcedures)
#! #CALL(%SetClassItem,'CodeMax' & %ActiveTemplateInstance)
#CALL(%SetClassItem,'Default')
#IF(%BaseClassToUse())
  #CALL(%FixClassName(ABC),%BaseClassToUse())
  #FOR(%pClassMethod)
    #FOR(%pClassMethodPrototype),WHERE(%MethodEmbedPointValid())
      #CALL(%SetupMethodCheck(ABC))
#EMBED(%CodeMaxMethodDataSection,'CodeMax Method Data Section'), %activeTemplateInstance, %pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(%FixClassName(%FixBaseClassToUse('Default'))),TREE(%GetEmbedTreeDesc('CodeMax Manager','DATA'))
  #?CODE
  #EMBED(%CodeMaxMethodCodeSection,'CodeMax Method Executable Code Section'), %activeTemplateInstance, %pClassMethod,%pClassMethodPrototype,PREPARE(%FixClassName(%FixBaseClassToUse('Default'))),TREE(%GetEmbedTreeDesc('CodeMax Manager','CODE'))
      #CALL(%CheckAddMethodPrototype(ABC),%ClassLines)
    #ENDFOR
  #ENDFOR
  #CALL(%GenerateNewLocalMethods,'CodeMax Manager')
#ENDIF
#ENDAT

#AT(%CodeMaxMethodCodeSection,%ActiveTemplateInstance), PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
  #CALL(%GenerateParentCall(ABC))
#END

#AT (%WindowEventHandling,'CloseWindow'),Priority(3700)
#IF(%CMProfileSave)
%ThisObjectName.SaveProfile()
#ENDIF
#ENDAT
#AT (%WindowEventHandling,'OpenWindow'),Priority(8900)
#IF(%CMProfileLoad)
%ThisObjectName.LoadProfile()
#ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'), PRIORITY(8030)
  #FIX(%Control, %GetControlName())
%ThisObjectName.m_ControlID = %ActiveTemplateInstance
#IF(%CMHelpFIle)
%ThisObjectName.HelpFileName = '%CMHelpFIle'
#ENDIF
IF ~%ThisObjectName.Init(0{prop:ClientHandle},%Control) THEN
  MESSAGE('CodeMax control cannot be created.')
END
#ENDAT
#AT (%WindowManagerMethodCodeSection,'Init', '(),BYTE'),Priority(9001)
%ThisObjectName.Open()
#ENDAT
#AT (%WindowEventHandling,'Sized'),Priority (7500),WHERE(%CMResize)
%ThisObjectName.Resize
#ENDAT
#!AT (%ResizerMethodCodeSection,1, 'Resize', '(),BYTE')
#!ENDAT
#AT (%WindowManagerMethodCodeSection,'Kill', '(),BYTE'),Priority(7300)
%ThisObjectName.Kill
#ENDAT

#AT (%WindowEventHandling,'OpenWindow'),Priority(5600)
#IF(%CMClarionLanguageSet)
%ThisObjectName.SetLanguage('Clarion')
#ENDIF
#ENDAT
#!------------------------------------------------------------------------------------------------
#GROUP(%GetControlName,%SearchReport=%False),PRESERVE      #!Gets the control name for the current active template
#IF(%Searchreport)
  #FIND(%ReportControlInstance,%ActiveTemplateInstance,%ReportControl)
  #RETURN (%ReportControl)
#ELSE
  #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
  #RETURN (%Control)
#END
#!------------------------------------------------------------------------------------------------
#GROUP(%NoCaseFix,*%Symbol,%FixValue),AUTO
#DECLARE(%i,LONG)
#FIX(%Symbol,%FixValue)
#IF(%Symbol NOT=%FixValue)
  #LOOP,FOR(%i,1,ITEMS(%Symbol))
    #SELECT(%Symbol,%i)
    #IF(UPPER(%Symbol)=UPPER(%FixValue))
      #BREAK
    #ENDIF
  #ENDLOOP
#ENDIF
#!------------------------------------------------------------------------------------------------
#GROUP(%BaseClassToUse)
#IF(%UseDefaultABCBaseClass)
  #IF(%ActualDefaultBaseClassType)
    #RETURN(%ActualDefaultBaseClassType)
  #ELSE
    #ASSERT(%DefaultBaseClassType,'%BaseClassToUse: Symbol %DefaultBaseClassType is being returned empty ['&%ClassItem&']')
    #RETURN(%DefaultBaseClassType)
  #ENDIF
#ELSIF(%UseABCBaseClass)
  #RETURN(%ABCBaseClass)
#ELSIF(~%UseABCBaseClass)
  #RETURN(%ExtBaseClass)
#ENDIF
#ASSERT(%False,'%BaseClassToUse: IF clauses all missed')
#!------------------------------------------------------------------------------------------------
#GROUP(%MethodEmbedPointValid)
#IF(UPPER(%pClassName)=UPPER(%BaseClassToUse()) AND ~%pClassMethodPrivate)
  #RETURN(%True)
#ENDIF
#RETURN(%False)
#!------------------------------------------------------------------------------------------------
#GROUP(%GetEmbedTreeDesc,%EmbedType,%ProcedureSection,%AdditionalLevels=''),AUTO
#DECLARE(%EmbedDesc)
#CASE(UPPER(%EmbedType))
#OF('FILE MANAGER')
#OROF('RELATION MANAGER')
#OROF('ERROR MANAGER')
#OROF('INI MANAGER')
#OROF('TRANSLATOR')
  #SET(%EmbedDesc,'Global Objects|')
#ELSE
  #SET(%EmbedDesc,'Local Objects{{PRIORITY(2000)}|')
#ENDCASE
#IF(%AdditionalLevels)
  #SET(%EmbedDesc,%EmbedDesc&%AdditionalLevels&'|')
#ENDIF
#SET(%EmbedDesc,%EmbedDesc&%GetObjectEmbedDesc(%EmbedType)&'|'&%GetObjectEmbedPrototype())
#CASE(UPPER(%ProcedureSection))
#OF('DATA')
  #SET(%EmbedDesc,%EmbedDesc&'|DATA')
  #IF(%ColorEntriesOnEmbeds)
    #SET(%EmbedDesc,%EmbedDesc&'{{COLOR('&%ColorDataSection&')}')
  #ENDIF
#OF('CODE')
  #SET(%EmbedDesc,%EmbedDesc&'|CODE')
  #IF(%ColorEntriesOnEmbeds)
    #SET(%EmbedDesc,%EmbedDesc&'{{COLOR('&%ColorCodeSection&'),PRIORITY(5000)}')
  #ELSE
    #SET(%EmbedDesc,%EmbedDesc&'{{PRIORITY(5000)}')
  #ENDIF
#ELSE
  #ASSERT(%False,'%GetEmbedTreeDesc: Unknown ProcedureSection')
#ENDCASE
#RETURN(%EmbedDesc)
#!------------------------------------------------------------------------------------------------
#GROUP(%GetObjectEmbedDesc,%EmbedType),AUTO
#DECLARE(%RVal)
#IF(%ShowBaseClassOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('FILE MANAGER')
    #SET(%RVal,%ThisObjectName&'  ('&%CacheFileManager&')')
  #OF('RELATION MANAGER')
    #SET(%RVal,%ThisObjectName&'  ('&%CacheRelationManager&')')
  #OF('ERROR MANAGER')
    #SET(%RVal,'GlobalErrors  ('&%ErrorManagerType&')')
  #OF('INI MANAGER')
    #SET(%RVal,'INIMgr  ('&%INIClass&')')
  #OF('TRANSLATOR')
    #SET(%RVal,'Translator  ('&%RunTimeTranslatorType&')')
  #ELSE
    #SET(%RVal,%ThisObjectName&'  ('&%BaseClassToUse()&')')
  #ENDCASE
#ENDIF
#IF(%ShowDescriptionOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('FILE MANAGER')
    #SET(%RVal,%RVal&'  File Manager for '&%File)
  #OF('RELATION MANAGER')
    #SET(%RVal,%RVal&'  Relation Manager for '&%File)
  #OF('ERROR MANAGER')
    #SET(%RVal,%Rval&'  Global Error Manager')
  #OF('INI MANAGER')
    #SET(%RVal,%RVal&'  Global INI Manager')
  #OF('TRANSLATOR')
    #SET(%RVal,%RVal&'  Global Run-Time Translator')
  #OF('DEFAULT BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  Default Locator for '&%ActiveTemplateInstanceDescription)
  #OF('BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  Conditional Locator for '&%ActiveTemplateInstanceDescription)
  #OF('DEFAULT BROWSE STEP')
    #SET(%RVal,%RVal&'  Default Step Manager for '&%ActiveTemplateInstanceDescription)
  #OF('BROWSE STEP')
    #SET(%RVal,%RVal&'  Conditional Step Manager for '&%ActiveTemplateInstanceDescription)
  #OF('EDIT IN PLACE')
    #SET(%RVal,%RVal&'  Edit-in-Place Manager')
  #OF('TOOLBAR MANAGER')
    #SET(%RVal,%RVal&'  Toolbar Manager')
  #OF('WINDOW MANAGER')
    #SET(%RVal,%RVal&'  Window Manager')
  #OF('BROWSE EIP MANAGER')
    #SET(%RVal, %RVal & ' Browse EIP Manager for ' & %ActiveTemplateInstanceDescription)
  #ELSE
    #SET(%Rval,%Rval&'  '&%ActiveTemplateInstanceDescription)
  #ENDCASE
#ENDIF
#IF(%ShowDetailsOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  [Condition: '&%SortCondition&']')
  #OF('BROWSE STEP')
    #SET(%RVal,%RVal&'  [Condition: '&%SortCondition&']')
  #OF('EDIT IN PLACE')
    #SET(%RVal,%RVal&'  [Field: '&%EditInPlaceField&']')
  #ENDCASE
#ENDIF
#ASSERT(%RVal,'%GetObjectEmbedDesc: Description being returned blank')
#RETURN(CLIP(LEFT(%RVal)))
#!
#!
#!------------------------------------------------------------------------------------------------
#GROUP(%GetObjectEmbedPrototype),AUTO
#EQUATE(%RVal,%pClassMethod)
#IF(%ShowPROCEDUREonEmbeds)
  #SET(%RVal,%RVal&' PROCEDURE')
#ENDIF
#IF(%pClassMethodPrototype<>'()')
  #SET(%RVal,%RVal&%pClassMethodPrototype)
#ENDIF
#IF(%ShowVIRTUALonEmbeds AND %pClassMethodVirtual)
  #SET(%RVal,%RVal&',VIRTUAL')
#ENDIF
#IF(%ShowPROTECTEDonEmbeds AND %pClassMethodProtected)
  #SET(%RVal,%RVal&',PROTECTED')
#ENDIF
#IF(%ColorEntriesOnEmbeds)
  #IF(%pClassMethodVirtual)
    #SET(%RVal,%RVal&'{{COLOR('&%ColorVirtualMethod&')}')
  #ELSIF(%pClassMethodProtected)
    #SET(%RVal,%RVal&'{{COLOR('&%ColorProtectedMethod&')}')
  #ENDIF
#ENDIF
#RETURN(%RVal)
#!
#!
#!------------------------------------------------------------------------------------------------
#GROUP(%ParentCallValid)
#IF(UPPER(%pClassMethod)='CONSTRUCT' OR UPPER(%pClassMethod)='DESTRUCT' OR %pClassMethod='')
  #RETURN(%False)
#ENDIF
#RETURN(%True)
#GROUP(%GenerateNewLocalMethods,%EmbedType='')
  #IF(%DeriveFromBaseClass)
    #FOR(%NewMethods)
%ThisObjectName.%NewMethodName %(%MethodDeclaration(%NewMethodPrototype))
      #SUSPEND
#?%NULL
#EMBED(%NewMethodDataSection,'New Class Method Data Section'),%ActiveTemplateInstance,%ClassItem,%NewMethods,LABEL,DATA,TREE(%GetNewMethodTreeDesc(%EmbedType,'DATA'))
      #RESUME
#?%NULL
  CODE
      #SUSPEND
  #EMBED(%NewMethodCodeSection,'New Class Method Code Section'),%ActiveTemplateInstance,%ClassItem,%NewMethods,TREE(%GetNewMethodTreeDesc(%EmbedType,'CODE'))
#?%NULL
#?%NULL
      #RESUME
    #ENDFOR
  #ENDIF
#GROUP(%SetClassItem,%Instance)
#IF(%Instance AND %ClassItem NOT=%Instance)
  #CALL(%NoCaseFix,%ClassItem,%Instance)
#ENDIF
#! ****************
#GROUP(%ActiveTemplateInstanceItems,%Symbol,*%InstanceItemsValue),AUTO
#DECLARE(%MyActiveTemplate)
#DECLARE(%MyActiveTemplateInstance)
#SET(%InstanceItemsValue,0)
#SET(%MyActiveTemplate,%ActiveTemplate)
#SET(%MyActiveTemplateInstance,%ActiveTemplateInstance)
#CALL(%NoCaseFix,%ActiveTemplate,%Symbol)
#SET(%InstanceItemsValue,ITEMS(%ActiveTemplateInstance))
#UNFIX(%ActiveTemplate)
#FIX(%ActiveTemplate,%MyActiveTemplate)
#FIX(%ActiveTemplateInstance,%MyActiveTemplateInstance)
